Index: libcfs/include/libcfs/list.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/list.h,v
retrieving revision 1.7
diff -u -p -r1.7 list.h
--- libcfs/include/libcfs/list.h	26 Oct 2009 08:08:19 -0000	1.7
+++ libcfs/include/libcfs/list.h	1 Jan 2010 20:03:32 -0000
@@ -1,46 +1,99 @@
 #ifndef __LIBCFS_LIST_H__
 #define __LIBCFS_LIST_H__
 
+/** \addtogroup libcfs
+ * @{ */
+
+/** \defgroup lists Lists
+ * @{ */
+
+/**
+ * \defgroup list List
+ * Simple doubly linked list implementation.
+ *
+ * Some of the internal functions ("__xxx") are useful when
+ * manipulating whole lists rather than single entries, as
+ * sometimes we already know the next/prev entries and we can
+ * generate better code by using them directly rather than
+ * using the generic single-entry routines.
+ *
+ * \defgroup hlist Hash List
+ * Double linked lists with a single pointer list head.
+ * Mostly useful for hash tables where the two pointer list head is too
+ * wasteful.  You lose the ability to access the tail in O(1).
+ */
+
 #if defined (__linux__) && defined(__KERNEL__)
 
 #include <linux/list.h>
 
+/** \addtogroup list
+ * @{ */
 #define CFS_LIST_HEAD_INIT(n)		LIST_HEAD_INIT(n)
 #define CFS_LIST_HEAD(n)		LIST_HEAD(n)
 #define CFS_INIT_LIST_HEAD(p)		INIT_LIST_HEAD(p)
+/* @} */
 
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
+/** \addtogroup hlist
+ * @{ */
 #define CFS_HLIST_HEAD_INIT		HLIST_HEAD_INIT
 #define CFS_HLIST_HEAD(n)		HLIST_HEAD(n)
 #define CFS_INIT_HLIST_HEAD(p)		INIT_HLIST_HEAD(p)
 #define CFS_INIT_HLIST_NODE(p)		INIT_HLIST_NODE(p)
+/* @} */
 #endif
 
 #else /* !defined (__linux__) || !defined(__KERNEL__) */
 
-/*
- * Simple doubly linked list implementation.
- *
- * Some of the internal functions ("__xxx") are useful when
- * manipulating whole lists rather than single entries, as
- * sometimes we already know the next/prev entries and we can
- * generate better code by using them directly rather than
- * using the generic single-entry routines.
+/**
+ * Prefetch the value of \a a to have it in CPU-cache in advance.
+ * Used in list manipulation primitives to increase performance.
  */
-
 #define prefetch(a) ((void)a)
 
+/** \addtogroup list
+ * @{ */
+
+/**
+ * There are two different use-cases for this structure:
+ *
+ * 1) An anchor keeping pointers necessary to iterate through the
+ * list forward starting from the first element and backward starting
+ * from the last.
+ * When used in this way, list_head should be initialized before use.
+ * The list is empty if and only if both \a next and \a prev point
+ * to the given list_head.
+ *
+ * 2) A storage (embedded in a structure describing list element) for
+ * pointers necessary for list manipulations like add, del, etc.
+ * No need of initialization in such use-case.
+ */
 struct list_head {
-	struct list_head *next, *prev;
+        /**
+         * points to:
+         *  - the first element of the list in the 1st use-case
+         *  - the next element of the list in the 2nd use-case
+         */
+	struct list_head *next;
+        /**
+         * points to:
+         *  - the last element of the list in the 1st use-case
+         *  - the previous element of the list in the 2nd use-case
+         */
+        struct list_head *prev;
 };
 
 typedef struct list_head list_t;
 
+/** Static initializer for list_head representing empty list */
 #define CFS_LIST_HEAD_INIT(name) { &(name), &(name) }
 
+/** Shortcut to declare and initialize list_head in one statement */
 #define CFS_LIST_HEAD(name) \
 	struct list_head name = CFS_LIST_HEAD_INIT(name)
 
+/** Initialize list_head at run time as representing empty list */
 #define CFS_INIT_LIST_HEAD(ptr) do { \
 	(ptr)->next = (ptr); (ptr)->prev = (ptr); \
 } while (0)
@@ -248,26 +301,37 @@ static inline void list_splice_init(stru
 #define list_for_each_safe(pos, n, head) \
 	for (pos = (head)->next, n = pos->next; pos != (head); \
 		pos = n, n = pos->next)
+/* @} list */
+
+/** \addtogroup hlist
+ * @{ */
 
 /**
- * \defgroup hlist Hash List
- * Double linked lists with a single pointer list head.
- * Mostly useful for hash tables where the two pointer list head is too
- * wasteful.  You lose the ability to access the tail in O(1).
- * @{
+ * An anchor keeping pointer to the first (\a first) element as start
+ * point for iteration through the list. hlist_head should be
+ * initialized before use.
+ * The list is empty if and only if \a first is equal to NULL.
  */
-
 struct hlist_head {
+        /** points to the first element of the hlist */
 	struct hlist_node *first;
 };
 
+/**
+ * A storage (embedded in a structure describing hlist element) for
+ * pointers necessary for list manipulations like add, del, etc.
+ * Should be initialized with CFS_INIT_HLIST_NODE to make hlist_unhashed
+ * working correctly. An element is regarded as 'unhashed' (i.e. not
+ * part of any hlist) if and only if \a pprev is equal to NULL.
+*/
 struct hlist_node {
-	struct hlist_node *next, **pprev;
+        /** points to the next element of the hlist */
+	struct hlist_node  *next;
+        /** points to the memory where \a next of previous element is stored */
+        struct hlist_node **pprev;
 };
 
-/* @} */
-
-/*
+/**
  * "NULL" might not be defined at this point
  */
 #ifdef NULL
@@ -276,14 +340,16 @@ struct hlist_node {
 #define NULL_P ((void *)0)
 #endif
 
-/**
- * \addtogroup hlist
- * @{
- */
-
+/** Static initializer for hlist_head representing empty hlist */
 #define CFS_HLIST_HEAD_INIT { NULL_P }
+
+/** Shortcut to declare and initialize hlist_head in one statement */
 #define CFS_HLIST_HEAD(name) struct hlist_head name = { NULL_P }
+
+/** Initialize hlist_head at run time as representing empty hlist */
 #define CFS_INIT_HLIST_HEAD(ptr) ((ptr)->first = NULL_P)
+
+/** Initialize hlist_node at run time as representing 'unhashed' element */
 #define CFS_INIT_HLIST_NODE(ptr) ((ptr)->next = NULL_P, (ptr)->pprev = NULL_P)
 
 #define HLIST_HEAD_INIT		CFS_HLIST_HEAD_INIT
@@ -296,11 +362,13 @@ static inline int hlist_unhashed(const s
 	return !h->pprev;
 }
 
+/** the same as list_empty but for hlist */
 static inline int hlist_empty(const struct hlist_head *h)
 {
 	return !h->first;
 }
 
+/** the same as __list_del but for hlist */
 static inline void __hlist_del(struct hlist_node *n)
 {
 	struct hlist_node *next = n->next;
@@ -310,11 +378,17 @@ static inline void __hlist_del(struct hl
 		next->pprev = pprev;
 }
 
+/**
+ * the same as list_del but for hlist.
+ * NOTE: n->pprev is not zeroed, so hlist_unhashed won't work
+ * as expected afterwards. Use hlist_del_init if it's needed.
+ */
 static inline void hlist_del(struct hlist_node *n)
 {
 	__hlist_del(n);
 }
 
+/** the same as list_del_init but for hlist */
 static inline void hlist_del_init(struct hlist_node *n)
 {
 	if (n->pprev)  {
@@ -323,6 +397,7 @@ static inline void hlist_del_init(struct
 	}
 }
 
+/** the same as list_add but for hlist */
 static inline void hlist_add_head(struct hlist_node *n, struct hlist_head *h)
 {
 	struct hlist_node *first = h->first;
@@ -333,7 +408,13 @@ static inline void hlist_add_head(struct
 	n->pprev = &h->first;
 }
 
-/* next must be != NULL */
+/**
+ * Insert an entry immediately before entry specified by \a next.
+ * \param n new entry to be inserted
+ * \param next existing entry before which \a n to be inserted
+ *
+ * \a next must be != NULL
+ */
 static inline void hlist_add_before(struct hlist_node *n,
 					struct hlist_node *next)
 {
@@ -343,6 +424,13 @@ static inline void hlist_add_before(stru
 	*(n->pprev) = n;
 }
 
+/**
+ * Insert an entry immediately after entry specified by \a next.
+ * \param n new entry to be inserted
+ * \param next existing entry after which \a n to be inserted
+ *
+ * \a next must be != NULL
+ */
 static inline void hlist_add_after(struct hlist_node *n,
 					struct hlist_node *next)
 {
@@ -354,12 +442,15 @@ static inline void hlist_add_after(struc
 		next->next->pprev  = &next->next;
 }
 
+/** the same as list_entry but for hlist */
 #define hlist_entry(ptr, type, member) container_of(ptr,type,member)
 
+/** the same as list_for_each but for hlist */
 #define hlist_for_each(pos, head) \
 	for (pos = (head)->first; pos && (prefetch(pos->next), 1); \
 	     pos = pos->next)
 
+/** the same as list_for_each_safe but for hlist */
 #define hlist_for_each_safe(pos, n, head) \
 	for (pos = (head)->first; pos && (n = pos->next, 1); \
 	     pos = n)
@@ -414,10 +505,13 @@ static inline void hlist_add_after(struc
 		({ tpos = hlist_entry(pos, typeof(*tpos), member); 1;}); \
 	     pos = n)
 
-/* @} */
+/* @} hlist */
 
 #endif /* __linux__ && __KERNEL__ */
 
+/** \addtogroup list
+ * @{ */
+
 #ifndef list_for_each_prev
 /**
  * Iterate over a list in reverse order
@@ -446,6 +540,7 @@ static inline void hlist_add_after(struc
 #endif /* list_for_each_entry */
 
 #ifndef list_for_each_entry_rcu
+/** The same as ::list_for_each_entry but for rcu-protected lists */
 #define list_for_each_entry_rcu(pos, head, member) \
 	list_for_each_entry(pos, head, member)
 #endif
@@ -518,6 +613,10 @@ static inline void hlist_add_after(struc
         for (n = list_entry(pos->member.next, type, member);            \
              &pos->member != (head);                                    \
              pos = n, n = list_entry(n->member.next, type, member))
+/* @} list */
+
+/** \addtogroup hlist
+ * @{ */
 #define cfs_hlist_for_each_entry_typed(tpos, pos, head, type, member)   \
 	for (pos = (head)->first;                                       \
 	     pos && (prefetch(pos->next), 1) &&                         \
@@ -529,5 +628,8 @@ static inline void hlist_add_after(struc
 	     pos && (n = pos->next, 1) && 				\
 		(tpos = hlist_entry(pos, type, member), 1);             \
 	     pos = n)
+/* @} hlist  */
+/* @} lists */
+/* @} libcfs */
 
 #endif /* __LIBCFS_LUSTRE_LIST_H__ */
Index: libcfs/include/libcfs/lltrace.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/lltrace.h,v
retrieving revision 1.3
diff -u -p -r1.3 lltrace.h
--- libcfs/include/libcfs/lltrace.h	7 Aug 2008 14:48:45 -0000	1.3
+++ libcfs/include/libcfs/lltrace.h	1 Jan 2010 20:03:32 -0000
@@ -52,6 +52,26 @@
 #error Unsupported Operating System
 #endif
 
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup libcfs_lltrace lltrace
+ * Thin layer between jt_dbg_* interface provided by
+ * lnet/utils/debug.c and lustre/tests/mkdirdeep
+ *
+ * lltrace hides peculiarities of jt_dbg_* interface allowing
+ * some test program (lustre/tests/mkdirdeep) to set in-kernel libcfs
+ * debug tunables (subsystem_debug and debug) and dump lustre log in
+ * specified file in easy way.
+ *
+ * It also provides function \a ltrace_add_processnames that adds
+ * output of "ps -e" system command to the tail of dumped logs in the
+ * format alike to the rest of logs.
+ *
+ * @{
+ */
+
 static inline int ltrace_write_file(char* fname)
 {
         char* argv[3];
@@ -199,4 +219,7 @@ static inline void ltrace_add_processnam
         system(cmdbuf);
 }
 
+/** @} libcfs_lltrace */
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/user-bitops.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-bitops.h,v
retrieving revision 1.6
diff -u -p -r1.6 user-bitops.h
--- libcfs/include/libcfs/user-bitops.h	8 Sep 2009 08:09:26 -0000	1.6
+++ libcfs/include/libcfs/user-bitops.h	1 Jan 2010 20:03:32 -0000
@@ -41,7 +41,25 @@
 #ifndef __LIBCFS_USER_BITOPS_H__
 #define __LIBCFS_USER_BITOPS_H__
 
-/* test if bit nr is set in bitmap addr; returns previous value of bit nr */
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_bitops
+ * @{ */
+
+/**
+ * \defgroup libcfs_userspace_bitops Bitmask (user-space)
+ * Bitmask operations (user-space).
+ *
+ * User-space implementation of bitmask primitives is NOT atomic. For
+ * example, two separate threads can easily race on test_and_set_bit,
+ * both returning zero if given bit was not set initially. It's not
+ * tidy but acceptable because the only consumer is single-threaded
+ * liblustre.
+ * @{
+ */
+
+/** set bit \a nr in bitmask \a addr
+ * \return previous value of bit \a nr */
 static __inline__ int test_and_set_bit(int nr, unsigned long *addr)
 {
         unsigned long mask;
@@ -55,7 +73,8 @@ static __inline__ int test_and_set_bit(i
 
 #define set_bit(n, a) test_and_set_bit(n, a)
 
-/* clear bit nr in bitmap addr; returns previous value of bit nr*/
+/** clear bit \a nr in bitmask \a addr
+ * \return previous value of bit \a nr */
 static __inline__ int test_and_clear_bit(int nr, unsigned long *addr)
 {
         unsigned long mask;
@@ -69,13 +88,24 @@ static __inline__ int test_and_clear_bit
 
 #define clear_bit(n, a) test_and_clear_bit(n, a)
 
+/** test bit \a nr in bitmap \a addr
+   \return the value of bit \a nr */
 static __inline__ int test_bit(int nr, const unsigned long *addr)
 {
         return ((1UL << (nr & (BITS_PER_LONG - 1))) &
                 ((addr)[nr / BITS_PER_LONG])) != 0;
 }
 
-/* using binary seach */
+/* __fls and __ffs use binary search */
+
+/**
+ * Find last non-zero bit in bitmask \a data
+ *
+ * \param data Bitmask
+ *
+ * \return 0 if failed to find non-zero bit, position of
+ * non-zero bit (counting from 1) otherwise
+ */
 static __inline__ unsigned long __fls(long data)
 {
 	int pos = 32;
@@ -115,6 +145,20 @@ static __inline__ unsigned long __fls(lo
 	return pos;
 }
 
+/**
+ * Find first non-zero bit in bitmask \a data
+ *
+ * \param data Bitmask
+ *
+ * \return sizeof(long)-1 if failed to find non-zero bit, position of
+ * non-zero bit (counting from 0) otherwise
+ *
+ * NOTE: the function returns the same value when:
+ * - \a data is equal to zero
+ * - \a data has the most significant bit set and other bits clear.
+ *
+ * Callers may check whether \a data == 0 to discriminate.
+ */
 static __inline__ unsigned long __ffs(long data)
 {
         int pos = 0;
@@ -147,7 +191,30 @@ static __inline__ unsigned long __ffs(lo
         return pos;
 }
 
+/**
+ * Find first zero bit in bitmask \a x
+ *
+ * \param x Bitmask
+ *
+ * \return sizeof(long)-1 if failed to find zero bit, position of
+ * zero bit (counting from 0) otherwise
+ *
+ * NOTE: the function returns the same value when:
+ * - \a x has all bits set
+ * - \a x has the most significant bit clear and other bits set.
+ *
+ * Callers may check whether \a data == ~0UL to discriminate.
+ */
 #define __ffz(x)	__ffs(~(x))
+
+/**
+ * Find last zero bit in bitmask \a x
+ *
+ * \param x Bitmask
+ *
+ * \return 0 if failed to find zero bit, position of
+ * zero bit (counting from 1) otherwise
+ */
 #define __flz(x)	__fls(~(x))
 
 unsigned long find_next_bit(unsigned long *addr,
@@ -156,7 +223,14 @@ unsigned long find_next_bit(unsigned lon
 unsigned long find_next_zero_bit(unsigned long *addr,
                                  unsigned long size, unsigned long offset);
 
+/** the same as find_next_bit but start search from the beginning of bitmask */
 #define find_first_bit(addr,size)       (find_next_bit((addr),(size),0))
+/** the same as find_next_zero_bit but start search from the beginning
+ *  of bitmask */
 #define find_first_zero_bit(addr,size)  (find_next_zero_bit((addr),(size),0))
 
+/** @} libcfs_userspace_bitops */
+/** @} libcfs_bitops */
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/user-lock.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-lock.h,v
retrieving revision 1.16
diff -u -p -r1.16 user-lock.h
--- libcfs/include/libcfs/user-lock.h	15 Sep 2009 21:09:24 -0000	1.16
+++ libcfs/include/libcfs/user-lock.h	1 Jan 2010 20:03:32 -0000
@@ -45,14 +45,33 @@
 #error Do not #include this file directly. #include <libcfs/libcfs.h> instead
 #endif
 
-/* Implementations of portable synchronization APIs for liblustre */
+/** \addtogroup libcfs
+ * @{ */
 
-/*
- * liblustre is single-threaded, so most "synchronization" APIs are trivial.
+/** \addtogroup libcfs_synchronization
+ * @{ */
+
+/**
+ * \defgroup libcfs_userspace_synchronization Synchronization (user-space)
+ * User-space implementation of general synchronization primitives.
  *
- * XXX Liang: There are several branches share lnet with b_hd_newconfig,
- * if we define lock APIs at here, there will be conflict with liblustre
- * in other branches.
+ * There are two main consumers for this API: pure single-threaded liblustre
+ * (when operation environment provides only one thread of execution for all
+ * Lustre subsystems including lnet and LNDs) and single-threaded liblustre in
+ * MT environment (when lnet and LNDs enjoy multi-threadness while liblustre
+ * still runs in one particular thread).
+ *
+ * To meet the former case, user-space Libcfs implements all synchronization
+ * primitives as trivial stubs assuming that no race-conditions are possible
+ * in single-threaded case. For the latter case, it provides MT-safe
+ * implementation for some primitives (cfs_completion and cfs_atomic) that
+ * lnet and LNDs really need in MT environment.
+ *
+ * The fact that even running in MT environment some primitives are MT-safe and
+ * others are not makes the code pretty confusing and prone for misuse.
+ * Hopefully, it will be fixed soon in the course of name-normalization efforts.
+ *
+ * @{
  */
 
 #ifndef __KERNEL__
@@ -67,8 +86,9 @@
  * Optional debugging (magic stamping and checking ownership) can be added.
  */
 
-/*
- * spin_lock
+/**
+ * \defgroup libcfs_userspace_spin_locks Spin-locks
+ * spin_lock (user-space, single-threaded)
  *
  * - spin_lock_init(x)
  * - spin_lock(x)
@@ -79,6 +99,7 @@
  * - spin_unlock_irqrestore(x, f)
  *
  * No-op implementation.
+ * @{
  */
 struct spin_lock {int foo;};
 
@@ -100,13 +121,18 @@ void spin_unlock_bh(spinlock_t *lock);
 static inline int spin_is_locked(spinlock_t *l) {return 1;}
 static inline void spin_lock_irqsave(spinlock_t *l, unsigned long f){}
 static inline void spin_unlock_irqrestore(spinlock_t *l, unsigned long f){}
+/** @} */
 
-/*
- * Semaphore
+/**
+ * \defgroup libcfs_userspace_semaphore Semaphore
+ * Semaphore (user-space, single-threaded)
  *
  * - sema_init(x, v)
  * - __down(x)
  * - __up(x)
+ *
+ * No-op implementation.
+ * @{
  */
 typedef struct semaphore {
     int foo;
@@ -115,14 +141,19 @@ typedef struct semaphore {
 void sema_init(struct semaphore *s, int val);
 void __down(struct semaphore *s);
 void __up(struct semaphore *s);
+/** @} */
 
-/*
- * Mutex:
+/**
+ * \defgroup libcfs_userspace_mutex Mutex
+ * Mutex (user-space, single-threaded)
  *
  * - init_mutex(x)
  * - init_mutex_locked(x)
  * - mutex_up(x)
  * - mutex_down(x)
+ *
+ * Direct mapping to no-op semaphores
+ * @{
  */
 #define DECLARE_MUTEX(name)     \
         struct semaphore name = { 1 }
@@ -135,13 +166,36 @@ void __up(struct semaphore *s);
 #define init_MUTEX(x)                   sema_init(x, 1)
 #define init_MUTEX_LOCKED(x)            sema_init(x, 0)
 #define init_mutex(s)                   init_MUTEX(s)
+/** @} */
 
-/*
- * Completion:
+/**
+ * \defgroup libcfs_userspace_completion Completion
+ * Completion (user-space, single-threaded)
  *
  * - init_completion(c)
  * - complete(c)
  * - wait_for_completion(c)
+ *
+ * User-space single-threaded completion API is the super-set of completion API
+ * for MT-environment. The source of complexity is that we have only one thread
+ * of execution, so a subsystem that needs to wait for completion must
+ * somehow relinquish execution control to allow another subsystem succeed. And,
+ * in turn, that another subsystem generating completion event, should somehow
+ * pass execution control back to the former.
+ *
+ * Essentially, there is only one additional API call for user-space
+ * single-threaded case: \a init_completion_module. It should be called once,
+ * usually while start-up, with the only argument of \a cfs_wait_handler_t
+ * type. This argument is some caller-specific callback that will be called
+ * every time as Libcfs decides to relinquish execution control imitating sleep
+ * waiting for resource. For example, \a wait_for_completion would call this
+ * callback if completion event were not arrived yet.
+
+ * It's responsibility of caller to implement proper task scheduling inside this
+ * callback fitting its needs. See lustre/ptlrpc/events.c ::liblustre_wait_event
+ * as example.
+ *
+ * @{ 
  */
 struct completion {
         unsigned int done;
@@ -162,16 +216,20 @@ int wait_for_completion_interruptible(st
         struct completion work = COMPLETION_INITIALIZER(work)
 
 #define INIT_COMPLETION(x)      ((x).done = 0)
+/** @} */
 
-
-/*
- * rw_semaphore:
+/**
+ * \defgroup libcfs_userspace_rw_semaphore Read-write semaphores
+ * rw_semaphore (user-space, single-threaded)
  *
  * - init_rwsem(x)
  * - down_read(x)
  * - up_read(x)
  * - down_write(x)
  * - up_write(x)
+ *
+ * No-op implementation.
+ * @{
  */
 struct rw_semaphore {
         int foo;
@@ -185,10 +243,11 @@ int down_write_trylock(struct rw_semapho
 void up_read(struct rw_semaphore *s);
 void up_write(struct rw_semaphore *s);
 void fini_rwsem(struct rw_semaphore *s);
+/** @} */
 
-/*
- * read-write lock : Need to be investigated more!!
- * XXX nikita: for now, let rwlock_t to be identical to rw_semaphore
+/**
+ * \defgroup libcfs_userspace_rw_lock Read-write locks
+ * read-write lock (user-space, single-threaded)
  *
  * - DECLARE_RWLOCK(l)
  * - rwlock_init(x)
@@ -196,6 +255,9 @@ void fini_rwsem(struct rw_semaphore *s);
  * - read_unlock(x)
  * - write_lock(x)
  * - write_unlock(x)
+ *
+ * Direct mapping to no-op rw_semaphores
+ * @{
  */
 typedef struct rw_semaphore rwlock_t;
 #define RW_LOCK_UNLOCKED        (rwlock_t) { }
@@ -216,10 +278,17 @@ static inline void
 read_lock_irqsave(rwlock_t *l, unsigned long f) { read_lock(l); }
 static inline void
 read_unlock_irqrestore(rwlock_t *l, unsigned long f) { read_unlock(l); }
+/** @} */
 
-/*
- * Atomic for user-space
- * Copied from liblustre
+/**
+ * \defgroup libcfs_userspace_atomic Atomics
+ * Atomic for single-threaded user-space
+ *
+ * Trivial implementation. Copied from liblustre.
+ *
+ * NOTE: Actually, these atomics are not atomic at all. Be careful not to use
+ * them in MT environment when access is possible from more than one thread.
+ * @{
  */
 typedef struct { volatile int counter; } atomic_t;
 
@@ -239,18 +308,30 @@ typedef struct { volatile int counter; }
 #define atomic_dec_return(a)  atomic_sub_return(1,a)
 #define atomic_add_unless(v, a, u) ((v)->counter != u ? (v)->counter += a : 0)
 #define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
-
+/** @} */
 
 #ifdef HAVE_LIBPTHREAD
 #include <pthread.h>
 
-/*
- * Completion
+/**
+ * \defgroup libcfs_userspace_mt_completion Completions (MT-safe)
+ * Completions (user-space, multi-threaded)
+ *
+ * MT-safe version of completion primitives is implemented on the top of
+ * pthread conditional variables (cond-vars). Usage is simple: the caller
+ * initialize cfs_completion with \a cfs_init_completion before spawning
+ * threads, then one thread can wait using \a cfs_wait_for_completion and
+ * another thread can wake-up the former using \a cfs_complete. That's it.
+ * @{
  */
 
+/** MT-safe verision of completion structure */
 struct cfs_completion {
+        /** flag - completion event happened */
         int c_done;
+        /** cond-var to sleep on */
         pthread_cond_t c_cond;
+        /** mutex to protect c_cond and c_done */
         pthread_mutex_t c_mut;
 };
 
@@ -258,9 +339,16 @@ void cfs_init_completion(struct cfs_comp
 void cfs_fini_completion(struct cfs_completion *c);
 void cfs_complete(struct cfs_completion *c);
 void cfs_wait_for_completion(struct cfs_completion *c);
+/** @} */
 
-/*
- * atomic.h
+/**
+ * \defgroup libcfs_userspace_mt_atomic Atomics (MT-safe)
+ * Atomics (user-space, multi-threaded)
+ *
+ * MT-safe version of atomic primitives is implemented using
+ * global pthread mutex protecting operations on
+ * cfs_atomic_t::counter.
+ * @{
  */
 
 typedef struct { volatile int counter; } cfs_atomic_t;
@@ -272,9 +360,13 @@ void cfs_atomic_inc(cfs_atomic_t *a);
 void cfs_atomic_dec(cfs_atomic_t *a);
 void cfs_atomic_add(int b, cfs_atomic_t *a);
 void cfs_atomic_sub(int b, cfs_atomic_t *a);
+/** @} */
 
 #endif /* HAVE_LIBPTHREAD */
 
+/** \addtogroup libcfs_userspace_mutex
+ * @{ */
+
 /**************************************************************************
  *
  * Mutex interface.
@@ -332,7 +424,7 @@ static inline void mutex_destroy(struct 
 {
 }
 
-/*
+/**
  * This is for use in assertions _only_, i.e., this function should always
  * return 1.
  *
@@ -345,13 +437,21 @@ static inline int mutex_is_locked(struct
         return 1;
 }
 
+/** @} libcfs_userspace_mutex */
 
 /**************************************************************************
  *
  * Lockdep "implementation". Also see lustre_compat25.h
  *
  **************************************************************************/
-
+/**
+ * \defgroup libcfs_userspace_lockdep Lockdep
+ * Dummy stubs imitating linux 'Lock-class' validator
+ *
+ * Needed only to compile some lustre code in both kernel- and user-space
+ * avoiding lengthy "#ifdef HAVE_LOCK_CLASS ... #endif" constructions.
+ * @{
+ */
 struct lock_class_key {
         int foo;
 };
@@ -368,17 +468,19 @@ static inline void lockdep_on(void)
 {
 }
 
-/* This has to be a macro, so that can be undefined in kernels that do not
- * support lockdep. */
 #define mutex_lock_nested(mutex, subclass) mutex_lock(mutex)
 #define spin_lock_nested(lock, subclass) spin_lock(lock)
 #define down_read_nested(lock, subclass) down_read(lock)
 #define down_write_nested(lock, subclass) down_write(lock)
-
+/** @} */
 
 /* !__KERNEL__ */
 #endif
 
+/** @} libcfs_userspace_synchronization */
+/** @} libcfs_synchronization */
+/** @} libcfs */
+
 /* __LIBCFS_USER_LOCK_H__ */
 #endif
 /*
Index: libcfs/include/libcfs/user-mem.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/user-mem.h,v
retrieving revision 1.4
diff -u -p -r1.4 user-mem.h
--- libcfs/include/libcfs/user-mem.h	4 Feb 2009 01:45:47 -0000	1.4
+++ libcfs/include/libcfs/user-mem.h	1 Jan 2010 20:03:32 -0000
@@ -9,13 +9,31 @@
 #error "This is only for user space."
 #endif
 
+/**
+ * \addtogroup libcfs
+ * @{
+ *
+ * \addtogroup libcfs_mem
+ * @{
+ *
+ * \defgroup libcfs_user_mem Memory Allocations (user-space)
+ * User-space implementation of API for memory allocations
+ * @{
+ */
 
 /* XXX
  * for this moment, liblusre will not rely OST for non-page-aligned write
  */
 #define LIBLUSTRE_HANDLE_UNALIGNED_PAGE
 
+/**
+ * User-space emulation of kernel page structure
+ *
+ * The only field of wide use is \a addr. All others are reserved for
+ * internal use in liblustre file i/o.
+ */
 typedef struct page {
+        /** CPU vaddr to access memory associated with this page */
         void   *addr;
         unsigned long index;
         struct list_head list;
@@ -70,11 +88,12 @@ static inline void *cfs_alloc(size_t nr_
 #define cfs_free_large(addr) cfs_free(addr)
 
 #define CFS_ALLOC_ATOMIC_TRY   (0)
-/*
- * SLAB allocator
+/**
+ * User-space SLAB allocator
  */
 typedef struct {
-         int size;
+        /** size of objects in this cache */
+        int size;
 } cfs_mem_cache_t;
 
 #define SLAB_HWCACHE_ALIGN 0
@@ -89,6 +108,9 @@ void *cfs_mem_cache_alloc(cfs_mem_cache_
 void cfs_mem_cache_free(cfs_mem_cache_t *c, void *addr);
 int cfs_mem_is_in_cache(const void *addr, const cfs_mem_cache_t *kmem);
 
+/** @} libcfs_user_mem */
+/** @} libcfs_mem */
+
 /*
  * Copy to/from user
  */
@@ -104,4 +126,5 @@ static inline int copy_to_user(void *a,v
         return 0;
 }
 
+/** @} libcfs */
 #endif
